-- Verify that UOM2 prices are possible (convert to UOM1 and back)
DECLARE curPriceLists CURSOR LOCAL FOR
SELECT U_PMX_UOM2PRICEUDF, CONVERT( NVARCHAR, PriceDec ) FROM OPLN, OADM WHERE ISNULL( U_PMX_UOM2PRICEUDF, '' ) <> ''

DECLARE @priceUDF NVARCHAR(20)
DECLARE @priceDecimals NVARCHAR(20)
DECLARE @getPriceUDFs NVARCHAR(500)
DECLARE @updatePriceUDFs NVARCHAR(500)


OPEN curPriceLists
FETCH NEXT FROM curPriceLists INTO @priceUDF, @priceDecimals
WHILE @@FETCH_STATUS >= 0
BEGIN
	SET @getPriceUDFs = 'SELECT OITM.ItemCode, U_' + @priceUDF + ',
		CEILING( FLOOR  ( U_' + @priceUDF + ' / U_PMX_DQU2 * POWER(10,' + @priceDecimals + ') ) * U_PMX_DQU2 ) / POWER(10,' + @priceDecimals + ') AS flooredPrice,
		CEILING( CEILING( U_' + @priceUDF + ' / U_PMX_DQU2 * POWER(10,' + @priceDecimals + ') ) * U_PMX_DQU2 ) / POWER(10,' + @priceDecimals + ') AS ceiledPrice
	FROM OITM WHERE U_PMX_DQU2 <> 0
AND ISNULL(U_'+ @priceUDF +',0) <> 0'

	--try to update OITM

	SET @updatePriceUDFs = 'UPDATE OITM SET OITM.U_' + @priceUDF + ' = tempTable.flooredPrice FROM OITM INNER JOIN ('+ @getPriceUDFs +') AS tempTable ON tempTable.ItemCode = OITM.ItemCode WHERE OITM.U_' +@priceUDF+ ' <> flooredPrice AND flooredPrice <> ceiledPrice'
	EXEC( @updatePriceUDFs )

	FETCH NEXT FROM curPriceLists INTO @priceUDF, @priceDecimals
END
CLOSE curPriceLists

