--This is for testing
declare @cardcode nvarchar(50)
set @cardcode = 'JD0004'
--End This is for testing


--Sales order
SELECT ORDR.DocNum, ORDR.DocDate, ORDR.CardCode, ORDR.CardName, RDR1.LineNum, RDR1.LineStatus, RDR1.ItemCode , 
RDR1.Dscription AS Description, ISNULL(RDR1.U_secoms,'') AS SecondDescription, NULL AS Picker, 
NULL AS Location, RDR1.Quantity as 'QuantitySTEH',RDR1.OpenQty as 'OpenQuantitySTEH',
ISNULL(RDR1.U_PMX_QTY2, 0) AS Quantity, RDR1.Quantity as 'QuantitySTEH', OITM.InvntRyUom as 'STEH',RDR1.U_PMX_UOM2 as 'VKEH',  
ROUND(ISNULL(RESERVED_QTY.Quantity, 0)/(CASE WHEN (RDR1.U_PMX_U2TU=0 OR RDR1.U_PMX_U2TU IS NULL )THEN 1 ELSE RDR1.U_PMX_U2TU END),2) AS QuantityPrepared, 
ISNULL(RDR1.U_PMX_QTY2, 0)-ROUND(ISNULL(RESERVED_QTY.Quantity, 0)/(CASE WHEN (RDR1.U_PMX_U2TU=0 OR RDR1.U_PMX_U2TU IS NULL )THEN 1 ELSE RDR1.U_PMX_U2TU END),2) AS QuantityOpen,
OITM.Onhand as 'QuantitySTEHOnHand',
ROUND((RDR1.Price*RDR1.Quantity)/(RDR1.Quantity/(CASE WHEN (RDR1.U_PMX_U2TU=0 OR RDR1.U_PMX_U2TU IS NULL )THEN 1 ELSE RDR1.U_PMX_U2TU END)),2) AS ItemPrice, 
RDR1.LineTotal,
(case 
when RDR1.Itemcode = '104469' then 'ORANGE'
when (ROUND(ISNULL(RDR1.OpenCreQty, 0), 2) - ROUND(ISNULL(RESERVED_QTY.Quantity, 0), 2)) = 0 or OITM.InvntItem = 'N' then 'DRKGREEN'
when (ROUND(ISNULL(OITM.IsCommited, 0), 2) <= ROUND(ISNULL(OITM.OnHand, 0), 2)) then 'GREEN' 
when (ROUND(ISNULL(RDR1.OpenQty, 0), 2) <= ROUND(ISNULL(OITM.OnHand, 0), 2)) then 'ORANGE' 
when (ROUND(ISNULL(RDR1.OpenQty, 0), 2) > ROUND(ISNULL(OITM.OnHand, 0), 2)) then 'RED' 
else '' end ) as 'Status'
FROM ORDR 
INNER JOIN RDR1 ON ORDR.DocEntry = RDR1.DocEntry 
INNER JOIN OITM ON RDR1.ItemcOde = OITM.ItemCode
LEFT JOIN
(
	SELECT ObjType, DocEntry,LineNum, SUM(Quantity) AS Quantity 
	FROM
	(
	SELECT BaseType AS ObjType,BaseEntry AS DocEntry,BaseLine AS LineNum, SUM(Quantity) AS Quantity FROM PMX_INLD WHERE BaseType='17' GROUP BY BaseType,BaseEntry,BaseLine
	UNION
	SELECT ObjType, DocEntry, LineNum, SUM(LockedQuantity) AS Quantity FROM PMX_DOLL WHERE ObjType='17' GROUP BY ObjType, DocEntry, LineNum
	) T1
	GROUP BY ObjType,DocEntry,LineNum
) RESERVED_QTY ON RESERVED_QTY.ObjType='17' AND RESERVED_QTY.DocEntry=RDR1.DocEntry AND RESERVED_QTY.LineNum=RDR1.LineNum
                  
WHERE     (ORDR.CardCode = @cardcode AND ORDR.DocStatus = 'O') and (OITM.InvntItem = 'Y' or OITM.InvntItem = 'N')


 
--Sales Invoice
SELECT OINV.DocNum, OINV.DocDate, OINV.CardCode, OINV.CardName, INV1.LineNum, INV1.LineStatus, INV1.ItemCode, 
INV1.Dscription AS Description, ISNULL(INV1.U_secoms,'') AS SecondDescription, NULL AS Picker, 
NULL AS Location, INV1.Quantity as 'QuantitySTEH',INV1.OpenQty as 'OpenQuantitySTEH',
ISNULL(INV1.U_PMX_QTY2,0) AS Quantity,INV1.Quantity as 'QuantitySTEH', OITM.InvntRyUom as 'STEH',INV1.U_PMX_UOM2 as 'VKEH', 
ROUND(ISNULL(RESERVED_QTY.Quantity, 0)/(CASE WHEN (INV1.U_PMX_U2TU=0 OR INV1.U_PMX_U2TU IS NULL )THEN 1 ELSE INV1.U_PMX_U2TU END),2) AS QuantityPrepared, 
ISNULL(INV1.U_PMX_QTY2, 0)-ROUND(ISNULL(RESERVED_QTY.Quantity, 0)/(CASE WHEN (INV1.U_PMX_U2TU=0 OR INV1.U_PMX_U2TU IS NULL )THEN 1 ELSE INV1.U_PMX_U2TU END),2) AS QuantityOpen,
OITM.Onhand as 'QuantitySTEHOnHand', 
ROUND((INV1.Price*INV1.Quantity)/(INV1.Quantity/(CASE WHEN (INV1.U_PMX_U2TU=0 OR INV1.U_PMX_U2TU IS NULL )THEN 1 ELSE INV1.U_PMX_U2TU END)),2) AS ItemPrice, 
INV1.LineTotal,
(case
when INV1.Itemcode = '104469' then 'ORANGE'
when (ROUND(ISNULL(INV1.OpenCreQty, 0), 2) - ROUND(ISNULL(RESERVED_QTY.Quantity, 0), 2)) = 0 or  OITM.Invntitem = 'N' then 'DRKGREEN'
when (ROUND(ISNULL(OITM.IsCommited, 0), 2) <= ROUND(ISNULL(OITM.OnHand, 0), 2)) then 'GREEN' 
when (ROUND(ISNULL(INV1.OpenQty, 0), 2) <= ROUND(ISNULL(OITM.OnHand, 0), 2)) then 'ORANGE' 
when (ROUND(ISNULL(INV1.OpenQty, 0), 2) > ROUND(ISNULL(OITM.OnHand, 0), 2)) then 'RED' 
else '' end ) as 'Status'

FROM         OINV 
INNER JOIN INV1 ON OINV.DocEntry = INV1.DocEntry 
INNER JOIN OITM ON INV1.ItemcOde = OITM.ItemCode
LEFT JOIN
(
	SELECT ObjType, DocEntry,LineNum, SUM(Quantity) AS Quantity 
	FROM
	(
	SELECT BaseType AS ObjType,BaseEntry AS DocEntry,BaseLine AS LineNum, SUM(Quantity) AS Quantity FROM PMX_INLD WHERE BaseType='13' GROUP BY BaseType,BaseEntry,BaseLine
	UNION
	SELECT ObjType, DocEntry, LineNum, SUM(LockedQuantity) AS Quantity FROM PMX_DOLL WHERE ObjType='13' GROUP BY ObjType, DocEntry, LineNum
	) T1
	GROUP BY ObjType,DocEntry,LineNum
) RESERVED_QTY ON RESERVED_QTY.ObjType='13' AND RESERVED_QTY.DocEntry=INV1.DocEntry AND RESERVED_QTY.LineNum=INV1.LineNum
                  
WHERE     (OINV.CardCode = @CardCode) AND (OINV.isIns = 'Y') AND ((OINV.DocStatus = 'O') or (INV1.opencreqty > 0)) 
and (OITM.Invntitem = 'Y' or OITM.Invntitem = 'N')



--select * from ocrd where cardtype = 'C' order by updatedate desc